/* Ejemplo1.c -> Ventana de fondo azul y letras amarillas */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <strings.h>
 
unsigned long ColorPorNombre( Display *, char * );
   
/*--- Funcion principal main() --------------------------------*/ 
main()
{
 Display *display;
 Window window;
 Font font;
 GC gc;
 XEvent evento;
 int pantalla;
 unsigned long azul, amarillo;
 char cadena[]="Esto deberia aparecer en amarillo sobre fondo azul.";
 XGCValues nuevo;
 
 display = XOpenDisplay( NULL );
 font = XLoadFont( display, "8x16" );
 pantalla = DefaultScreen( display );
 azul = ColorPorNombre( display, "blue");
 amarillo = ColorPorNombre( display, "yellow" );
 
 window = XCreateSimpleWindow( display,
            DefaultRootWindow( display ), 350, 0, 500, 400,
            1, amarillo, azul );
 
 XSelectInput( display, window, ButtonPressMask | KeyPressMask );
 XMapWindow( display, window );
 gc = XCreateGC( display, window, 0, NULL );
 nuevo.foreground=amarillo;
 XChangeGC( display, gc, GCForeground, &nuevo);
 XSetFont( display, gc, font );
 
 while( 1 )
 {
               
  XNextEvent( display, &evento );
  switch( evento.type )
  {
   case ButtonPress:
    XDrawString( display, window, gc,
                 evento.xbutton.x,
                 evento.xbutton.y, 
                 "X", 1);
    XDrawString( display, window, gc, 10, 150,
                 cadena, strlen(cadena));
    break;

    case KeyPress:   exit(0); 
  }
 }
}

/*--- Rutina para localizar colores por nombre ----------------*/
unsigned long ColorPorNombre( Display *display, char *Nombre )
{
  XColor color, temp;
  XAllocNamedColor( display,
     DefaultColormap(display,DefaultScreen(display)),
     Nombre, &color, &temp );
  return( color.pixel );
}
                  