/* Ejemplo2 -> Mapa de colores */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
 
#define ANCHO 8
#define ALTO  20
 
void main()
{
  Display *display;
  Window madre, hija;
  Colormap mapa;
  XColor borde, fondo, temp;
  int numColores, f;
  XSetWindowAttributes atributos;
 
  display = XOpenDisplay( NULL );
  mapa = DefaultColormap( display, DefaultScreen( display ) );
  numColores = XDisplayCells( display, DefaultScreen( display ) );
  printf( "\nHay %d colores en el DefaultColormap.", numColores );
 
  XAllocNamedColor( display, mapa, "yellow", &borde, &temp );
  XAllocNamedColor( display, mapa, "blue",   &fondo, &temp );
 
  madre = XCreateSimpleWindow( display, DefaultRootWindow( display ), 0, 0,
          (ANCHO*numColores) + 10, ALTO + 10, 10, borde.pixel, fondo.pixel );
 
  atributos.override_redirect = True;
  XChangeWindowAttributes( display, madre, CWOverrideRedirect, &atributos );
 
  XMapWindow( display, madre );
  XFlush( display );
 
  for ( f=0; f<numColores; f++)
  {
    hija = XCreateSimpleWindow( display, madre,
            (f*ANCHO)+5, 5, ANCHO, ALTO, 0, f, f );
    XMapWindow( display, hija );
  }
    XFlush(display);
    getchar();
}

